      PROGRAM MAIN

      PARAMETER(NX=15,NY=15)
      REAL UX(NX), UY(NY)
      REAL UYW(NX), UXW(NY) 
      REAL TX(NX,NY), TY(NX,NY)
      REAL Z(NX,NY)
      REAL TERRAIN(NX)

      CALL GLRGET('RUNDEF',RUNDEF)

*     <<< TEST 1: TERRAIN FOLLOWING COORDINATE >>>

*     < SET PARAMETERS >

      DO I=1,NX
         UX(I)=(I-1.0)/(NX-1.0) - 0.5
         TERRAIN(I) = 0.1 * EXP(-24*UX(I)**2)
      ENDDO
      DO J=1,NY
         UY(J)=(J-1.0)/(NY-1.0)
      ENDDO

      TX(1,1) = RUNDEF
      DO J=1,NY
         DO I=1,NX
            TY(I,J) = UY(J)*(1.0-TERRAIN(I)) + TERRAIN(I)
         ENDDO
      ENDDO

      TXMIN = UX(1)
      TXMAX = UX(NX)
      TYMIN = 0
      TYMAX = 1.0

*     < GRAPHIC >

C      CALL SWLSET('LDUMP',.TRUE.)    ! Best with gropn(4)
      CALL GROPN(1)
      CALL SLDIV('Y',2,1)
      CALL UZFACT(1.2)
      CALL SGLSET('LCORNER',.FALSE.)

      CALL GRFRM
      CALL GRSWND(TXMIN,TXMAX,TYMIN,TYMAX)
      CALL GRSVPT(0.15,0.85,0.15,0.85)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL USDAXS
      CALL UXSTTL('T','TERRAIN FOLLOWING',0.0)

      CALL GRSTRN(50)
      CALL GRSWND(UX(1),UX(NX),UY(1),UY(NY))
      CALL SGSITR(NX, NY, UX,UY, TX,TY, TXMIN,TXMAX,TYMIN,TYMAX)
      CALL GRSTRF

*     / TONE /

      DO J=1,NY
         DO I=1,NX
            Z(I,J) = UX(I) * (1-UY(J))
         ENDDO
      ENDDO

      CALL UELSET('LTONE',.TRUE.)
      CALL UWSGXA(UX,NX)
      CALL UWSGYA(UY,NY)
      CALL UETONE(Z, NX, NX, NY)

*     / GRID LINES /

      DO J=1,NY
        DO I=1,NX
          UYW(I) = UY(J)
        ENDDO
        CALL SGPLU(NX,UX,UYW)
      ENDDO

      DO I=1,NX
        DO J=1,NY
          UXW(J) = UX(I)
        ENDDO
        CALL SGPLU(NY,UXW,UY)
      ENDDO

*     <<< TEST 2: CHANGE BOTH X AND Y >>>

*     < SET PARAMETERS >

      DO I=1,NX
         UX(I)=(I-1.0)/(NX-1.0)
      ENDDO
      DO J=1,NY
         UY(J)=(J-1.0)/(NY-1.0)
      ENDDO

      DO J=1,NY
         DO I=1,NX
            TX(I,J) = UX(I) + 0.1*UY(J)
            TY(I,J) = 0.2*UX(I) + UY(J)
         ENDDO
      ENDDO

      TXMIN = 0.0
      TXMAX = 1.1
      TYMIN = 0
      TYMAX = 1.1

*     < GRAPHIC >

      CALL GLLSET('LMISS',.TRUE.)

      CALL GRFRM
      CALL GRSWND(TXMIN,TXMAX,TYMIN,TYMAX)
      CALL GRSVPT(0.15,0.85,0.15,0.85)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL USDAXS
      CALL UXSTTL('T','BOTH X & Y TRANSFORMED',0.0)

      CALL GRSTRN(50)
      CALL GRSWND(UX(1),UX(NX),UY(1),UY(NY))
      CALL SGSITR(NX, NY, UX,UY, TX,TY, TXMIN,TXMAX,TYMIN,TYMAX)
      CALL GRSTRF

      CALL SGLSET('LCLIP',.TRUE.)

*     / TONE /

      DO J=1,NY
         DO I=1,NX
            Z(I,J) = UX(I) + UY(J)
         ENDDO
      ENDDO

      CALL UELSET('LTONE',.TRUE.)
      CALL UWSGXA(UX,NX)
      CALL UWSGYA(UY,NY)
      CALL UETONE(Z, NX, NX, NY)

*     / GRID LINES /

      DO J=1,NY
        DO I=1,NX
          UYW(I) = UY(J)
        ENDDO
        CALL SGPLU(NX,UX,UYW)
      ENDDO

      DO I=1,NX
        DO J=1,NY
          UXW(J) = UX(I)
        ENDDO
        CALL SGPLU(NY,UXW,UY)
      ENDDO

      CALL GRCLS

      END
